@echo off
REM COPY A BLUE IRIS CAMERA'S MOST RECENT ALERT IMAGE 
REM AND STORE ITS FILESPEC IN A BLUE IRIS MACRO
REM BY JAYDEEL @ IPCAMTALK

if "%1" == "" goto Error
set CamName=%1

REM ======================================
REM USER INPUTS
REM ... Blue Iris Alerts folder (do not terminate w/ slash!)
REM     NOTE: Most Blue Iris install do not contain a space between 'Blue' and 'Iris'
set source=D:\Blue Iris\Alerts
REM ... Destination folder (do not terminate w/ slash!)
set dest=D:\Blue Iris\Alerts_Latest
REM ... Blue Iris macro number used to store destination filespec
set bimacro=777
REM ... Or unique macro numbers for each camera.
set bimacro[DW1]=661
set bimacro[DW2]=662
set bimacro[FE]=663
set bimacro[FD]=664
set bimacro[GT]=665
REM ... Blue Iris web server's address
REM     This script requires admin access
set biserver_url=http://192.168.1.3:8600
REM ======================================

REM GET CAM'S LATEST *.JPG FILE (ALERT IMAGE)
REM REF: https://stackoverflow.com/a/25996556
for /f "delims=" %%f in ('dir "%source%\%CamName%*.jpg" /b /o:d /a:-d') do (
	set LAST=%%f
)

REM SAVE ALERT IMAGE TO FILE NAMED LIKE 'camname_latest.jpg'
REM echo Copying image: %LAST%
copy "%source%\%LAST%" "%dest%\%CamName%_latest.jpg

REM REPLACE SPACES IN DESINATION FILESPEC WITH %20 (FOR CURL URL)
set txt=%dest%\%CamName%_latest.jpg
setLocal EnableDelayedExpansion
set txt=!txt: =%%20!

REM LOAD COPIED FILESPEC TO A BLUE IRIS MACRO
curl.exe "%biserver_url%/admin?macro=%bimacro%&text=%txt%" > nul
set x=!bimacro[%CamName%]!
curl.exe "%biserver_url%/admin?macro=%x%&text=%txt%" > nul

goto End

:Error
echo.
echo Usage: %0 cam_shortname
echo.

:End